from scipy import stats as stats
from scipy._lib._util import check_random_state as check_random_state
from scipy._typing import Untyped
from ._qmc import Halton as Halton, QMCEngine as QMCEngine

__all__ = ["FastGeneratorInversion", "RatioUniforms"]

def argus_pdf(x, chi) -> Untyped: ...
def argus_gamma_trf(x, chi) -> Untyped: ...
def argus_gamma_inv_trf(x, chi) -> Untyped: ...
def betaprime_pdf(x, a, b) -> Untyped: ...
def beta_valid_params(a, b) -> Untyped: ...
def gamma_pdf(x, a) -> Untyped: ...
def invgamma_pdf(x, a) -> Untyped: ...
def burr_pdf(x, cc, dd) -> Untyped: ...
def burr12_pdf(x, cc, dd) -> Untyped: ...
def chi_pdf(x, a) -> Untyped: ...
def chi2_pdf(x, df) -> Untyped: ...
def alpha_pdf(x, a) -> Untyped: ...
def bradford_pdf(x, c) -> Untyped: ...
def crystalball_pdf(x, b, m) -> Untyped: ...
def weibull_min_pdf(x, c) -> Untyped: ...
def weibull_max_pdf(x, c) -> Untyped: ...
def invweibull_pdf(x, c) -> Untyped: ...
def wald_pdf(x) -> Untyped: ...
def geninvgauss_mode(p, b) -> Untyped: ...
def geninvgauss_pdf(x, p, b) -> Untyped: ...
def invgauss_mode(mu) -> Untyped: ...
def invgauss_pdf(x, mu) -> Untyped: ...
def powerlaw_pdf(x, a) -> Untyped: ...

PINV_CONFIG: Untyped

class CustomDistPINV:
    def __init__(self, pdf, args) -> None: ...
    def pdf(self, x) -> Untyped: ...

class FastGeneratorInversion:
    def __init__(
        self, dist, *, domain: Untyped | None = None, ignore_shape_range: bool = False, random_state: Untyped | None = None
    ): ...
    @property
    def random_state(self) -> Untyped: ...
    @random_state.setter
    def random_state(self, random_state): ...
    @property
    def loc(self) -> Untyped: ...
    @loc.setter
    def loc(self, loc): ...
    @property
    def scale(self) -> Untyped: ...
    @scale.setter
    def scale(self, scale): ...
    def rvs(self, size: Untyped | None = None) -> Untyped: ...
    def ppf(self, q) -> Untyped: ...
    def qrvs(self, size: Untyped | None = None, d: Untyped | None = None, qmc_engine: Untyped | None = None) -> Untyped: ...
    def evaluate_error(self, size: int = 100000, random_state: Untyped | None = None, x_error: bool = False) -> Untyped: ...
    def support(self) -> Untyped: ...

class RatioUniforms:
    def __init__(self, pdf, *, umax, vmin, vmax, c: int = 0, random_state: Untyped | None = None): ...
    def rvs(self, size: int = 1) -> Untyped: ...
